## theano 1.0.5+dfsg

=== doc/requirements.txt ===
.. |PythonDistRecommended| replace:: The development package (python-dev or python-devel on most Linux distributions) is recommended (see just below)
.. |PlatformCompiler| replace:: ``g++`` (Linux and Windows), ``clang`` (OS X)

.. |CompilerName| replace:: ``g++`` (Windows/Linux) or ``Clang`` (OS X)
.. include:: requirements.inc

=== doc/omlw2014/Makefile ===
all: presentation.pdf sharing.pdf

clean:
	rm -f pygpu_ndarray.so core.* *.o *~

cleantmp:
	rm -f core.* *.o *~

presentation.pdf: presentation.tex
	pdflatex presentation
	pdflatex presentation

sharing.pdf: sharing.tex
	pdflatex sharing
	pdflatex sharing

=== debian/changelog ===
theano (1.0.5+dfsg-8) unstable; urgency=medium

  * Tests: ignore triu return dtype,
    re-disable some recently enabled tests, fix typos.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Mon, 14 Nov 2022 22:11:42 +0000

theano (1.0.5+dfsg-7) unstable; urgency=medium

  * Tests: fix some incompatibilities with pytest,
    install tests directory, run autopkgtest on installed version.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 13 Nov 2022 19:33:41 +0000

theano (1.0.5+dfsg-6) unstable; urgency=medium

  * Use pytest instead of nose for tests.  (Closes: #1018649)
  * Update Lintian override format (see #1007002).
  * Enable Salsa CI reprotest.
  * Bump Standards-Version to 4.6.1 (no changes needed).
  * Remove (long untested) support for old Cython.
  * Stop treating nodoc profile as also nocheck.
  * d/watch: Stop following Aesara, as even 1.x may be incompatible.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 06 Nov 2022 16:06:49 +0000

theano (1.0.5+dfsg-5) unstable; urgency=medium

  * Use terser.  (Closes: #1001030)
  * Enable Salsa CI, but skip the build-time tests there.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sat, 02 Apr 2022 19:52:33 +0100

theano (1.0.5+dfsg-4) unstable; urgency=medium

  * Docs: stop using add_stylesheet.  (Closes: #997382)
  * Tests: use POCL_DEVICES=basic on armel/armhf (workaround for #997908).
  * Add/update Lintian overrides.
  * Update Built-Using.
  * Update d/watch.
  * Add missing build-dependencies for PDF documentation.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 14 Nov 2021 13:47:39 +0000

theano (1.0.5+dfsg-3) unstable; urgency=medium

  * Tests: stop using clblas and skip-not-installable.  (Closes: #993107)
  * Bump Standards-Version to 4.6.0 (no changes needed).

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 29 Aug 2021 15:25:55 +0100

theano (1.0.5+dfsg-2) unstable; urgency=medium

  * Allow cross-building.  (Closes: #980485)  Thanks to Helmut Grohne.
  * Bump Standards-Version to 4.5.1 (no changes needed).
  * Upstream have moved.  Update watch file.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sat, 06 Feb 2021 13:35:30 +0000

theano (1.0.5+dfsg-1) unstable; urgency=medium

  * New upstream release (by a new maintainer).  Drop/refresh patches.
  * Update d/copyright.
  * Use uglifyjs.terser (see #968137).
  * Don't skip sympy-using tests.
  * Bump debhelper compat to 13.
  * Don't use /usr/lib/python3/dist-packages/bin.  (Closes: #967006)
  * Run autopkgtests on the installed module not the source tree.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 16 Aug 2020 13:33:47 +0100

theano (1.0.4+dfsg-3) unstable; urgency=medium

  * Use packaged (but still build-time copied) dagre* and graphlib.
  * Embedded graphlib-dot: update, verbose build, run tests,
    fix build with pegjs 0.10 (Closes: #959758).

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 06 May 2020 22:59:23 +0100

theano (1.0.4+dfsg-2) unstable; urgency=medium

  * Allow building with Sphinx 2.  (Closes: #955065)
  * Fix SyntaxWarnings.  (Closes: #950463)
  * Bump Standards-Version to 4.5.0 (no changes needed).
  * Fix exceptions / test failures with current numpy and scipy.
  * Fail the build on test failures.  With the above, Closes: #955471.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Thu, 02 Apr 2020 18:48:22 +0100

=== debian/control ===
Source: theano
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Rebecca N. Palmer <rebecca_palmer@zoho.com>
Build-Depends:
#for the build proper
 debhelper-compat (= 13),
 dh-python,
 cython3 (>> 0.29~),
#runtime dependencies - needed for the test suite and for the documentation build
# No python3-pygpu etc because some GPU tests are known to fail under OpenCL
 python3-dev,
 python3-setuptools,
 python3-six,
 libblas-dev,
 python3-numpy,
 python3-scipy,
 python3-pytest,
 python3-pydot,
 python3-sympy <!nocheck>,
 graphviz,
#for README.html build
 python3-docutils,
#for building Javascript dependencies (of d3viz)
 node-browserify-lite,
 terser,
 node-pegjs,
 node-graphlibrary,
 node-dagre-d3-renderer,
 node-lodash,
 node-istanbul,
 mocha,
 chai,
 libjs-d3
Build-Depends-Indep:
#for the documentation build
 dh-sequence-sphinxdoc,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 python3-pygments,
 dvipng,
 texlive-latex-extra,
 texlive-fonts-recommended,
 tex-gyre,
 fonts-texgyre,
 latexmk,
 rdfind,
 symlinks,
 jupyter-nbconvert,
 python3-ipykernel,
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: http://www.deeplearning.net/software/theano/
Vcs-Git: https://salsa.debian.org/science-team/theano.git
Vcs-Browser: https://salsa.debian.org/science-team/theano

# nvidia-cuda-toolkit should be at least Recommends, but it's in Suggests here to
# keep the package in main.

Package: python3-theano
Architecture: any
Section: python
Depends:
 ${python3:Depends},
 python3-dev,
 libblas-dev | libblas.so,
 ${misc:Depends}
Recommends:
 g++,
 python3-pydot,
 python3-pkg-resources,
 python3-pygpu,
 libgpuarray-dev,
 cython3,
 graphviz
Suggests:
 nvidia-cuda-toolkit,
 python3-pycuda,
 theano-doc
Breaks: python3-lasagne (<< 0.1+git20180322.37ca134)
Built-Using: ${javascriptBU}
Description: CPU/GPU math expression compiler for Python 3
 Theano is a Python library that allows one to define and evaluate mathematical
 expressions involving multi-dimensional arrays efficiently. It provides a
 high-level Numpy like expression language for functional description of
 calculation, rearranges expressions for speed and stability, and generates
 native machine instructions for fast calculation. Optionally, highly
 accelerated computations could be carried out on graphics cards processors.
 .
 This package contains Theano for Python 3.

Package: theano-doc
Architecture: all
Section: doc
Depends:
 ${sphinxdoc:Depends},
 ${misc:Depends}
Suggests:
 python3-theano
Built-Using: ${javascriptBU}
Description: CPU/GPU math expression compiler for Python (docs)
 Theano is a Python library that allows one to define and evaluate mathematical
 expressions involving multi-dimensional arrays efficiently. It provides a
 high-level Numpy like expression language for functional description of
 calculation, rearranges expressions for speed and stability, and generates
 native machine instructions for fast calculation. Optionally, highly
 accelerated computations could be carried out on graphics cards processors.
 .
 This package contains the documentation for Theano.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
#export DEB_BUILD_OPTIONS=nocheck
export PYBUILD_NAME=theano
export PYBUILD_INSTALL_ARGS=--install-scripts=/usr/share/{package}
export THEANO_FLAGS=base_compiledir='.pybuild',device=cpu
export PYTHONPATH=$(CURDIR)
export TEST_BASE_DIR=$(CURDIR)
export HOME=$(CURDIR)/jupyter_tmp
DO_PACKAGES=$(shell dh_listpackages)

# split up the test suite to work around the memory leak #898126
# don't try to run files that aren't (normal) tests, in particular _test_mpi_roundtrip.py, *.c, *.h, because this may error out (see 1.1.2+dfsg-2 build log)
export PYBUILD_TEST_ARGS=TEST_SUCCESS=true; cd $$TEST_BASE_DIR ; for TEST_SUBSET in $$TEST_BASE_DIR/theano/tests/ $$TEST_BASE_DIR/theano/*/tests/ $$TEST_BASE_DIR/theano/*/*/tests/ $$TEST_BASE_DIR/theano/sparse/sandbox/test_sp.py ; do LOCALE_OVERRIDE=C {interpreter} -m pytest -s  --confcutdir=$$TEST_BASE_DIR/theano $$TEST_SUBSET || test $$? = 5 || TEST_SUCCESS=false ; done ; $$TEST_SUCCESS

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_clean:
	mv theano/bin -T bin || true
	rm -rf theano/d3viz/js/*.min.js doc/library/d3viz/examples/d3viz/js/*.min.js debian/missing-source/*.js debian/missing-source/lodash debian/missing-source/graphlib-dot/bower.json debian/missing-source/graphlib-dot/lib/dot-grammar.js debian/missing-source/graphlib-dot/lib/version.js debian/missing-source/graphlib-dot/dist doc/.pybuild doc/library/d3viz/.pybuild Theano.egg-info theano/scan_module/c_code/scan_perform.c jupyter_tmp
	make -C debian/missing-source/graphlib-dot clean
	dh_auto_clean

override_dh_auto_build:
	# note this assumes all modules referenced via 'node_modules' are under /usr/share, not /usr/lib
	ln -s /usr/share/nodejs debian/missing-source/graphlib-dot/node_modules
	#graphlib-dot.js
	cd debian/missing-source && patch -p1 < js_fixes.diff
	make -C debian/missing-source/graphlib-dot --always-make dist
	cp debian/missing-source/graphlib-dot/dist/graphlib-dot.min.js theano/d3viz/js
	cd debian/missing-source && patch -p1 -R < js_fixes.diff
	#dagre-d3.js
	cp /usr/share/nodejs/dagre-d3/dist/dagre-d3.min.js theano/d3viz/js
	#d3 - workaround for #745688
	terser /usr/share/javascript/d3/d3.js -m -c --comments '@license' -o theano/d3viz/js/d3.v3.min.js
	cp theano/d3viz/js/*.min.js doc/library/d3viz/examples/d3viz/js
	# put the scripts in theano not a generic directory - #967006
	mv bin -T theano/bin
	#the cython code is the only part of theano itself that needs building - the C code is runtime compiled
	cd $(CURDIR)/theano/scan_module && cython3 scan_perform.pyx
	#remove relative paths from comments - they are unreproducible (depends on the number of levels in the build path) and probably wrong when installed
	cd $(CURDIR)/theano/scan_module && sed -iE -e 's#/\* "[./]*usr/lib/#/\* "/usr/lib/#g' scan_perform.c
	cd $(CURDIR)/theano/scan_module && mv scan_perform.c -t c_code
	#documentation
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
ifneq (,$(filter theano-doc,$(DO_PACKAGES)))
	sed -i -e "s/!pip/#!pip/g" doc/library/d3viz/index.ipynb
	mkdir jupyter_tmp
	#check that we can run this, but throw away the result because it's unreproducible (profiling output)
	cp $(CURDIR)/doc/library/d3viz/index.ipynb jupyter_tmp && jupyter-nbconvert --to notebook --execute $(CURDIR)/jupyter_tmp/index.ipynb --output $(CURDIR)/jupyter_tmp/test.ipynb
	#...but do use the ipynb-to-html-etc conversion
	jupyter-nbconvert --to html doc/library/d3viz/index.ipynb
	sed -i -e "s/#!pip/!pip/g" doc/library/d3viz/index.ipynb
	python3 doc/scripts/docgen.py
endif
	rst2html README.rst README.html
	cat NEWS.txt HISTORY.txt | gzip -n -9 > NEWS.gz
endif

override_dh_auto_install:
	dh_auto_install
	#autopkgtest needs this, and at this point the directory is called python3.10 (it presumably gets renamed to python3 later)
	cp -r theano/tests debian/python3-theano/usr/lib/python*/dist-packages/theano
	rm -fv debian/python*-theano/usr/lib/python*/dist-packages/theano/misc/check_blas_many.sh


override_dh_auto_test:
	PYBUILD_SYSTEM=custom dh_auto_test

override_dh_installdocs:
	dh_installdocs -A README.html NEWS.gz
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
ifneq (,$(filter theano-doc,$(DO_PACKAGES)))
	rdfind -outputname /dev/null -makesymlinks true debian/theano-doc
	symlinks -r -s -c debian/theano-doc
endif
endif

override_dh_installchangelogs:
	#the -X is meant as "don't try to install upstream changelog, only Debian's" - #906827
	dh_installchangelogs -Xtxt

override_dh_sphinxdoc:
	dh_sphinxdoc
	rm -fv debian/theano-doc/usr/share/doc/theano-doc/html/_sources/LICENSE.txt # extra-license-file

override_dh_compress:
	dh_compress -X.py -X.ipynb -X.pdf # save theano-doc/html/_downloads

override_dh_gencontrol:
	dh_gencontrol -- -VjavascriptBU="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), \n' -W node-lodash)$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), \n' -W libjs-d3)"

=== debian/tests/control ===
Tests: import
Depends: python3-theano
Restrictions: allow-stderr

Tests: selectedupstreamtests
Depends: python3-theano,
 g++,
 python3-pydot,
 python3-pytest,
 python3-pkg-resources,
 cython3,
 graphviz
Restrictions: allow-stderr

# Check that OpenCL isn't totally broken (note that it isn't totally working either)
# Uses device 0 platform 0, i.e. to use a real GPU manually install its opencl-icd before running this
# Architecture restriction is because pocl-opencl-icd is not available on all architectures
Tests: smoketestgpu
Architecture: amd64 arm64 armel armhf i386
Depends: python3-theano,
 g++,
 python3-pydot,
 python3-pytest,
 python3-pkg-resources,
 cython3,
 graphviz,
 pocl-opencl-icd,
 python3-pygpu,
 libclblast-dev,
 libgpuarray-dev
Restrictions: allow-stderr

=== debian/watch ===
version=4
# old upstream (current package)
opts="filenamemangle=s/(?:.*)rel-(\d[\d\.]+)\.tar\.gz/theano-$1.tar.gz/,repacksuffix=+dfsg,dversionmangle=s/\+dfsg[0-9]*//" \
https://github.com/theano/theano/releases (?:.*/)?rel-(\d[\d\.]+)\.tar\.gz
# new upstream (not in use because even 1.x might break compatibility)
# 1.x only (in experimental) https://github.com/aesara-devs/aesara/tags?after=rel-2.0.0 .*/rel-(1[\d\.]+)\.tar\.gz
# current (2.x - should probably be a new 'aesara' package if it is to be packaged at all)
# https://github.com/aesara-devs/aesara/tags .*/rel-(1[\d\.]+)\.tar\.gz
